From 9b252f56d1cad3e12001829bbb61c51cc742e9e0 Mon Sep 17 00:00:00 2001
From: Michael Paquier <michael@paquier.xyz>
Date: Tue, 18 Jun 2024 10:59:31 +0900
Subject: [PATCH 2/4] Add assertion in pgstat_write_statsfile()

This routine can currently only be called from the postmaster in
single-user mode or the checkpointer, so make sure that this is always
the case.
---
 src/backend/utils/activity/pgstat.c | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/src/backend/utils/activity/pgstat.c b/src/backend/utils/activity/pgstat.c
index 824f742bde..9cdd986582 100644
--- a/src/backend/utils/activity/pgstat.c
+++ b/src/backend/utils/activity/pgstat.c
@@ -1317,6 +1317,9 @@ pgstat_write_statsfile(XLogRecPtr redo)
 
 	pgstat_assert_is_up();
 
+	/* should be called only by the checkpointer or single user mode */
+	Assert(!IsUnderPostmaster || MyBackendType == B_CHECKPOINTER);
+
 	/* we're shutting down, so it's ok to just override this */
 	pgstat_fetch_consistency = PGSTAT_FETCH_CONSISTENCY_NONE;
 
-- 
2.45.1

